void module_setup() {
  /* Модули с меню 
   *  PULT - 0
   *  IP - 1
   *  Остальные номера задаются по порядку
   */
    #if defined (IR_PIN)
      setup_IR(); 
    #endif
    #if defined (SR501_PIN)
      setup_SR501();
    #endif
    #if defined (WS2812_PIN)
      setup_WS2812();
    #endif
    #if defined (MAX_TIMER)
      setup_TIMER();
      parsing_TIMER("STARTUP");  // Запустить таймеры с  именем "STARTUP"
    #endif
    #if defined (DHT_PIN)
      setup_DHT_22();
    #endif
    #if defined (MAX_ALARMS)
      setup_Alarms();
    #endif
    #if defined (BTN_PIN)
      setup_G_Button();
    #endif
    #if defined (MAX_SENDS)
      setup_SENDS();
      main_menu+="Trans,";
    #endif
    #if defined (DFPlayer)
      setup_DFPlayer();
    #endif

//--------------------------------------------------------
    main_menu+="-?-";
  
  // Модули без меню
    #if defined (RELE_PIN)
      setup_G220();
    #endif
    #if defined (PWM_PIN)
      setup_PWM();
    #endif
    #if defined (GyverLamp)
      setup_GyverLamp();
    #endif
    
}
//--------------------------------------------------------
void module_loop() {
    #if defined (MAX_ALARMS)
      loop_Alarms();
      yield();
    #endif
    #if defined (IR_PIN)
      loop_IR();
    #endif
    #if defined (RELE_PIN)
      loop_G220();
    #endif
    #if defined (SR501_PIN)
      loop_SR501();
      yield();
    #endif
    #if defined (MAX_SENDS)
      loop_SENDS();
    #endif
    #if defined (GyverLamp)
      loop_GyverLamp();
    #endif
    #if defined (PWM_PIN)
      loop_PWM();
    #endif
    #if defined (MAX_TIMER)
      loop_TIMER();
      yield();
    #endif
    #if defined (WS2812_PIN)
      loop_WS2812();
      yield();
    #endif
    #if defined (DHT_PIN)
      loop_DHT_22();
      yield();
    #endif
    #if defined (BTN_PIN)
      loop_G_Button();
    #endif
    #if defined (DFPlayer)
      loop_DFPlayer();
    #endif
}
//--------------------------------------------------------
void module_get() {
    #if defined (RELE_PIN)
      get_G220();  
    #endif
    #if defined (PWM_PIN)
      get_PWM();  
    #endif
    #if defined (SR501_PIN)
      get_SR501();
    #endif
    #if defined (DFPlayer)
      get_DFPlayer();
    #endif
    #if defined (WS2812_PIN)
      get_WS2812();
    #endif
}
//--------------------------------------------------------
void IP_parsig(GHflags mod,char act[]) {
 FOR_i(0,MAX_IP)  
   if (mod.get(i))
    if (ip_addr[i].on_off) send_console(ip_addr[i].ipchr,act);
}
//--------------------------------------------------------
void module_parsig(GHflags mod,char act[]) {
//    DEBUG("module_parsig : ");
//    DEBUGLN(act);  
    #if defined (MAX_ALARMS)
      parsing_Alarm(act);
    #endif
    #if defined (MAX_SENDS)
      parsing_SENDS(act);
    #endif
    #if defined (RELE_PIN)
      if (mod.get(0)) parsing_G220(act);  
    #endif
    #if defined (PWM_PIN)
      if (mod.get(1)) parsing_PWM(act);  
    #endif
    #if defined (WS2812_PIN)
      if (mod.get(2)) parsing_WS2812(act);  
    #endif
    #if defined (MAX_TIMER)
      if (mod.get(3)) parsing_TIMER(act);  
    #endif
    #if defined (DFPlayer)
      if (mod.get(4)) parsing_DFPlayer(act);
    #endif
}
//--------------------------------------------------------
void module_load(){
    Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
    //-------------
    load_IP();
    //-------------
    #if defined (MAX_ALARMS)
      load_Alarms();
    #endif
    #if defined (IR_PIN)
      load_IR();
    #endif
    #if defined (SR501_PIN)
      load_SR501();
    #endif
    #if defined (MAX_SENDS)
      load_SENDS();
    #endif
    #if defined (MAX_SENDS)
      load_TIMER();
    #endif
    //-------------
    Udp.endPacket();
}
//--------------------------------------------------------
void module_pult_HUB() {
   #if defined (GyverLamp)
       HUB_module_Pult_GyverLamp();
   #endif
   #if defined (RELE_PIN)
       HUB_module_G220();
   #endif
   #if defined (PWM_PIN)
       HUB_module_PWM();
   #endif
   #if defined (WS2812_PIN)
       HUB_module_pult_WS2812();
   #endif
   #if defined (MAX_TIMER)
       HUB_module_pult_TIMER();
   #endif
   #if defined (DFPlayer)
       HUB_module_pult_DFPlayer();
   #endif
}
//--------------------------------------------------------
void module_HUB(uint8_t tab) {
//--------------------------------------------------
        #if defined (MAX_ALARMS)
        if (getValue(main_menu,',',tab)==ALARM_MENU)  HUB_module_Alarm();
        #endif
//--------------------------------------------------
        #if defined (IR_PIN)
        if (getValue(main_menu,',',tab)==IR_MENU)     HUB_module_IR();
        #endif
//--------------------------------------------------
        #if defined (SR501_PIN)
        if (getValue(main_menu,',',tab)==SR501_MENU)  HUB_module_SR501();
        #endif
//--------------------------------------------------
        #if defined (MAX_SENDS)
        if (getValue(main_menu,',',tab)=="Trans")     HUB_module_SENDS();
        #endif
//--------------------------------------------------
        #if defined (MAX_TIMER)
        if (getValue(main_menu,',',tab)==TIMER_MENU)  HUB_module_TIMER();
        #endif
//--------------------------------------------------
        #if defined (DHT_PIN)
        if (getValue(main_menu,',',tab)==DHT_MENU)    HUB_module_DHT_22();
        #endif
//--------------------------------------------------
        #if defined (WS2812_PIN)
        if (getValue(main_menu,',',tab)==WS2812_MENU) HUB_module_WS2812();
        #endif
//--------------------------------------------------
        #if defined (BTN_PIN)
        if (getValue(main_menu,',',tab)==BTN_MENU)    HUB_module_G_Button();
        #endif
//--------------------------------------------------
        #if defined (DFPlayer)
        if (getValue(main_menu,',',tab)==DFP_MENU)    HUB_module_DFPlayer();
        #endif
//--------------------------------------------------
}
