#if defined (DHT_PIN)

#define MAX_DHT_22  10
#define DHT_Menu "выкл,температура >,температура <,влажность >,влажность <"

#include "DHT.h"

DHT dht(DHT_PIN, DHT22);
float humidity;
float temperature;

//--------------------------------------------------------
struct struct_DHT_22{
  bool on_off;
  char cmd_on[CMD_LEN];       // Посылаемая команда при сработке
  char cmd_on_rep[CMD_LEN];   // Посылаемая команда во время сработки
  int16_t h_t;           // температура / влажность для сравнения
  uint8_t choice;        // 0 - нет выбора, 1 - t>, 2 - t<, 3 - h>, 4 - h<
  uint32_t time_from=0;
  uint32_t time_to=0;
  GHflags week=0;
  GHflags lamp=0;
  GHflags modul=0;
  bool ok=true;
};
struct_DHT_22 DHT_22[MAX_DHT_22];
FS_(DHT_22);


//--------------------------------------------------------
void setup_DHT_22(){
  FS_LOAD(DHT_22); 
  dht.begin();
  main_menu+=DHT_MENU;
  main_menu+=",";
  delay(1000);
}

//--------------------------------------------------------
void action_DHT(uint8_t i) {
  if (DHT_22[i].ok) if (strlen(DHT_22[i].cmd_on)) {  //запуск таймера
     module_parsig(DHT_22[i].modul,DHT_22[i].cmd_on);
     IP_parsig(DHT_22[i].lamp,DHT_22[i].cmd_on);
     DHT_22[i].ok=false;
    }
  if (strlen(DHT_22[i].cmd_on_rep)) {  //запуск таймера
     module_parsig(DHT_22[i].modul,DHT_22[i].cmd_on_rep);
     IP_parsig(DHT_22[i].lamp,DHT_22[i].cmd_on_rep);
    }
}
//--------------------------------------------------------
void loop_DHT_22(){
  FS_TICK(DHT_22); 
  EVERY_MS(5000) { 
     humidity = dht.readHumidity(); //Измеряем влажность
     temperature = dht.readTemperature(); //Измеряем температуру
     if (hub.focused() && HUB_Update) {
       hub.sendUpdate("temperature", String(temperature,2)+" °");
       hub.sendUpdate("humidity", String(humidity,2)+" 🜁");
       HUB_Update=false;
     }
     FOR_i(0,MAX_DHT_22) if (DHT_22[i].choice) {
       bool on_time=false;
       if (DHT_22[i].time_from==DHT_22[i].time_to) on_time=true;
          else {
          if (DHT_22[i].time_from<DHT_22[i].time_to) 
              on_time=(hour*60+minute>=round(DHT_22[i].time_from/60)) && (hour*60+minute<=round(DHT_22[i].time_to/60));
          else    
              on_time=(hour*60+minute>=round(DHT_22[i].time_from/60)) || (hour*60+minute<=round(DHT_22[i].time_to/60));
          } 
       if (on_time && DHT_22[i].week.get(dayofweek)) switch (DHT_22[i].choice) {
         case 1: if (temperature>DHT_22[i].h_t) action_DHT(i);  break;
         case 2: if (temperature<DHT_22[i].h_t) action_DHT(i);  break;
         case 3: if (humidity>DHT_22[i].h_t) action_DHT(i);     break;
         case 4: if (humidity<DHT_22[i].h_t) action_DHT(i);     break;
       } else DHT_22[i].ok=true;
     }
  }  
}
//--------------------------------------------------------
void parsing_DHT_22(char act_chr[]){

}
//--------------------------------------------------------
void HUB_module_DHT_22() {
  static uint8_t plus_minus[MAX_DHT_22];
  static uint8_t tab = 0;
  hub.WidgetSize(50);
  hub.Label_(F("temperature"), String(temperature,2)+" °",F("Температура"));
  hub.Label_(F("humidity"), String(humidity,2)+" 🜁" ,F("Влажность"));
  FOR(tab,0,MAX_DHT_22) {
    hub.WidgetSize(50);
    hub.Select(&DHT_22[tab].choice,DHT_Menu);
    hub.WidgetSize(30);
    eeprom_flag |= hub.Input(&DHT_22[tab].h_t,GH_INT16, F("Значение"));
    hub.WidgetSize(20);
    hub.Tabs(&plus_minus[tab]," - , + ");
    if (plus_minus[tab]) {
       hub.WidgetSize(100);
       eeprom_flag |= hub.Flags(&DHT_22[tab].week, str_dayofweek,F("Дни недели"));
       hub.WidgetSize(50);
       eeprom_flag |= hub.Time(&DHT_22[tab].time_from, F("From") );
       eeprom_flag |= hub.Time(&DHT_22[tab].time_to, F("To"));
       hub.WidgetSize(100);
       eeprom_flag |= hub.Input(&DHT_22[tab].cmd_on,      GH_CSTR, F("Команда при сработке"),HUB_LEN,"",GH_GREEN);
       eeprom_flag |= hub.Input(&DHT_22[tab].cmd_on_rep,  GH_CSTR, F("Команда во время сработки"),HUB_LEN,"",GH_GREEN);
       eeprom_flag |= hub.Flags(&DHT_22[tab].lamp, str_GHflags_IP,F("Кому отсылаем"));
       eeprom_flag |= hub.Flags(&DHT_22[tab].modul, str_modul,F(hlp_modul));
    }
  }
  if (eeprom_flag) {
      FS_UPDATE(DHT_22);
      eeprom_flag=false;
   }
}
//--------------------------------------------------------
void load_DHT_22(){

}
#endif
