#if defined (RELE_PIN)
// Управление РЕЛЕ на пинах
/*
 * Обрабатываются команды
 * P_ON       - включит все реле
 * P_OFF      - выключит все реле
 * RELE 0 ON  - включить реле 0
 * RELE 1 OFF - выключить реле 0
 * Если номер реле больше или равен количеству действует на все
 */

// Для ESP-01 Пин 0 - GPIO0, 2 - GPIO2  {0} , {0,2}

bool rele[RELE_PIN]={false};
bool old_rele[RELE_PIN]={false};

//--------------------------------------------------------
void RELE(uint8_t pin, bool offon) {
 FOR_i(0,RELE_PIN) {
   if ((i==pin) || (pin>=RELE_PIN)) {
     digitalWrite(pin_220[i],not offon);
     rele[i] = offon;
     }
   }
}
//--------------------------------------------------------
void setup_G220() {
  FOR_i(0,RELE_PIN) pinMode(pin_220[i],OUTPUT);
}
//--------------------------------------------------------
void loop_G220() {
  FOR_i(0,RELE_PIN) digitalWrite(pin_220[i],not rele[i]);
}
//--------------------------------------------------------
// Парсит команды из Ararm,Сети,ИК
void parsing_G220(char act_chr[]) {
    String act=String(act_chr);
    memcpy(old_rele, rele, RELE_PIN);
//    DEBUGLN(act);
    String strCommand=getValue(act,' ',0);
    strCommand.toUpperCase();
//    DEBUGLN(strCommand);
    if ((strCommand=="RELE") || (strCommand=="РЕЛЕ") || (strCommand=="Реле")) {
        String pinstr = getValue(act,' ',1);
        uint8_t pin=pinstr.toInt();
        if (getValue(act,' ',2)=="ON") RELE(pin,true);
        if (getValue(act,' ',2)=="OFF") RELE(pin,false);
    }
    if (strCommand=="P_ON") RELE(RELE_PIN,true);
    if (strCommand=="P_OFF") RELE(RELE_PIN,false);
    if ((strCommand=="ON_OFF") || (strCommand=="SWITCH")) RELE(RELE_PIN,!rele[0]);

    FOR_i(0,RELE_PIN) {
       char send_udp[25];
       sprintf_P(send_udp, (const char *)F("RELE %d IS %s"), i, (rele[i]) ? "ON":"OFF");
       module_parsig(8,send_udp);
    }
}
//--------------------------------------------------------

void HUB_module_G220() {
  FOR_i(0,RELE_PIN) {
     hub.WidgetSize(74);
     hub.Display("rele 220V "+String(i),"Rele 220V "+String(i),GH_RED, 1, 18);
     hub.WidgetSize(26);
  if (hub.Switch_("sw_rele"+String(i),&rele[i],F("Включить"))) RELE(i,rele[i]);
  }
}

//--------------------------------------------------------
void get_G220() {
  char send_udp[25];
  FOR_i(0,RELE_PIN) {
     Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
     sprintf_P(send_udp, (const char *)F("RELE %d IS %s"), i, (rele[i]) ? "ON":"OFF");
     Udp.write(send_udp);
     Udp.endPacket();
  }
}  

#endif
