#if defined (WS2812_PIN)
#if (WS2812_D==1)  // Лента, Кольцо

#include <FastLED.h>

#define NUM_LEDS    16 // Количество светодиодов в кольце

#define MAX_EFF     20 //Количество эффектов

#define NAME_EFF   "Ночник,Цветоворот,Радуга,Круговорот,Облака,Лава,Плазма,Хаос,Павлин,Лес,Океан,Апельсин,Огонь,\
Пламя,\
Lithium,\
Лимон,\
Трава,\
Небо,\
Рубидий,\
Калий,\
Зебра,\
Цвет"



uint16_t speed = 20;     // speed is set dynamically once we've started up
uint16_t scale = 30;     // scale is set dynamically once we've started up

uint8_t colorLoop = 1;
uint8_t hue = 0;

uint8_t noise[NUM_LEDS];

extern const TProgmemRGBPalette16 WaterfallColors_p FL_PROGMEM = {0x000000, 0x060707, 0x101110, 0x151717, 0x1C1D22, 0x242A28, 0x363B3A, 0x313634, 0x505552, 0x6B6C70, 0x98A4A1, 0xC1C2C1, 0xCACECF, 0xCDDEDD, 0xDEDFE0, 0xB2BAB9};
extern const TProgmemRGBPalette16 WoodFireColors_p FL_PROGMEM = {CRGB::Black, 0x330e00, 0x661c00, 0x992900, 0xcc3700, CRGB::OrangeRed, 0xff5800, 0xff6b00, 0xff7f00, 0xff9200, CRGB::Orange, 0xffaf00, 0xffb900, 0xffc300, 0xffcd00, CRGB::Gold};             //* Orange
extern const TProgmemRGBPalette16 NormalFire_p FL_PROGMEM = {CRGB::Black, 0x330000, 0x660000, 0x990000, 0xcc0000, CRGB::Red, 0xff0c00, 0xff1800, 0xff2400, 0xff3000, 0xff3c00, 0xff4800, 0xff5400, 0xff6000, 0xff6c00, 0xff7800};                             // пытаюсь сделать что-то более приличное
extern const TProgmemRGBPalette16 NormalFire2_p FL_PROGMEM = {CRGB::Black, 0x560000, 0x6b0000, 0x820000, 0x9a0011, CRGB::FireBrick, 0xc22520, 0xd12a1c, 0xe12f17, 0xf0350f, 0xff3c00, 0xff6400, 0xff8300, 0xffa000, 0xffba00, 0xffd400};                      // пытаюсь сделать что-то более приличное
extern const TProgmemRGBPalette16 LithiumFireColors_p FL_PROGMEM = {CRGB::Black, 0x240707, 0x470e0e, 0x6b1414, 0x8e1b1b, CRGB::FireBrick, 0xc14244, 0xd16166, 0xe08187, 0xf0a0a9, CRGB::Pink, 0xff9ec0, 0xff7bb5, 0xff59a9, 0xff369e, CRGB::DeepPink};        //* Red
extern const TProgmemRGBPalette16 SodiumFireColors_p FL_PROGMEM = {CRGB::Black, 0x332100, 0x664200, 0x996300, 0xcc8400, CRGB::Orange, 0xffaf00, 0xffb900, 0xffc300, 0xffcd00, CRGB::Gold, 0xf8cd06, 0xf0c30d, 0xe9b913, 0xe1af1a, CRGB::Goldenrod};           //* Yellow
extern const TProgmemRGBPalette16 GrassFireColors_p FL_PROGMEM = {CRGB::Black, 0x001a00, 0x003300, 0x004d00, 0x006600, CRGB::Green, 0x239909, 0x45b313, 0x68cc1c, 0x8ae626, CRGB::GreenYellow, 0x94f530, 0x7ceb30, 0x63e131, 0x4bd731, CRGB::LimeGreen};     //* Green
extern const TProgmemRGBPalette16 SkyFireColors_p FL_PROGMEM = {CRGB::Black, 0x000033, 0x000066, 0x000099, 0x0000cc, CRGB::Blue, 0x0026ff, 0x004cff, 0x0073ff, 0x0099ff, CRGB::DeepSkyBlue, 0x1bc2fe, 0x36c5fd, 0x51c8fc, 0x6ccbfb, CRGB::LightSkyBlue};  //* Blue
extern const TProgmemRGBPalette16 RubidiumFireColors_p FL_PROGMEM = {CRGB::Black, 0x0f001a, 0x1e0034, 0x2d004e, 0x3c0068, CRGB::Indigo, CRGB::Indigo, CRGB::Indigo, CRGB::Indigo, CRGB::Indigo, CRGB::Indigo, 0x3c0084, 0x2d0086, 0x1e0087, 0x0f0089, CRGB::DarkBlue};        //* Indigo
extern const TProgmemRGBPalette16 PotassiumFireColors_p FL_PROGMEM = {CRGB::Black, 0x0f001a, 0x1e0034, 0x2d004e, 0x3c0068, CRGB::Indigo, 0x591694, 0x682da6, 0x7643b7, 0x855ac9, CRGB::MediumPurple, 0xa95ecd, 0xbe4bbe, 0xd439b0, 0xe926a1, CRGB::DeepPink}; //* Violet
extern const TProgmemRGBPalette16 ZebraColors_p FL_PROGMEM = {CRGB::White, CRGB::Black, CRGB::Black, CRGB::Black, CRGB::White, CRGB::Black, CRGB::Black, CRGB::Black, CRGB::White, CRGB::Black, CRGB::Black, CRGB::Black, CRGB::White, CRGB::Black, CRGB::Black, CRGB::Black,}; //* Zebra

/*
const TProgmemRGBPalette16 *palette_arr[] = {
  &PartyColors_p,
  &OceanColors_p,
  &LavaColors_p,
  &HeatColors_p,
  &WaterfallColors_p,
  &CloudColors_p,
  &ForestColors_p,
  &RainbowColors_p,
  &RainbowStripeColors_p
};

//const TProgmemRGBPalette16 *curPalette = palette_arr[0];
*/
CRGBPalette16 currentPalette(PartyColors_p);

uint8_t Real_EFF = 0;
bool Power_EFF = false;
uint8_t BRI=128;
uint8_t SPD=128;
uint8_t SCA=128;
uint8_t CLR=0;

CRGB leds[NUM_LEDS];  // создаём кольцо


//--------------------------------------------------------
struct struct_WS2812{
  bool on_off;
  char cmd[15];
  uint8_t BRI;
  uint8_t SPD;
  uint8_t SCA;
  bool ok=true;
};
/struct_WS2812 WS2812_R[MAX_EFF];
FS_(WS2812_R);
//--------------------------------------------------------
void setup_WS2812(){
  FS_LOAD(WS2812_R); 
//  FastLED.addLeds<WS2812, WS2812_PIN, BRG>(leds, NUM_LEDS);  // инициализация светодиодов (RGB,BRG - порядок цветов)
  FastLED.addLeds<WS2812, WS2812_PIN, GRB>(leds, NUM_LEDS);  // инициализация светодиодов (RGB,BRG - порядок цветов) 
  main_menu+=WS2812_MENU;
  main_menu+=",";
}
//--------------------------------------------------------
#define EFFECT_N(x,clp) \
currentPalette=(x);\
colorLoop = (clp);\
fillNoiseLED();\


void loop_WS2812(){
  FS_TICK(WS2812_R); 
//  effect_windows_round(128);
  FastLED.setBrightness(BRI);
  EVERY_MS(256U-SPD) 
  if (Power_EFF)
  switch (Real_EFF) {
    case 0: LEDS.showColor(CHSV(60,128,255));       break; // Ночник
    case 1: LEDS.showColor(CHSV(hue++,255,255));   break; // Цветоворот
    case 2: effect_rainbow();                   break; // Радуга
    case 3: effect_windows_round(SCA);          break; // Груговорот
    case 4: EFFECT_N(CloudColors_p,0)           break; // Oблaкa
    case 5: EFFECT_N(LavaColors_p,0)            break; // Лaвa 
    case 6: EFFECT_N(PartyColors_p,1)           break; // Плазма 
    case 7: EFFECT_N(RainbowColors_p,1)         break; // Хаос
    case 8: EFFECT_N(RainbowStripeColors_p,1)   break; // Пaвлин
    case 9: EFFECT_N(ForestColors_p,0)          break; // Лес
    case 10: EFFECT_N(OceanColors_p,0)          break; // Океан
    case 11: EFFECT_N(WoodFireColors_p,0)       break; // Апельсин
    case 12: EFFECT_N(NormalFire_p,0)           break; // Огонь
    case 13: EFFECT_N(NormalFire2_p,0)          break; // Огонь с сиреневым

    case 14: EFFECT_N(LithiumFireColors_p,0)    break; // 
    case 15: EFFECT_N(SodiumFireColors_p,0)     break; // Лимон
    case 16: EFFECT_N(GrassFireColors_p,0)      break; // 
    case 17: EFFECT_N(SkyFireColors_p,0)        break; // Небо
    case 18: EFFECT_N(RubidiumFireColors_p,0)   break; // 
    case 19: EFFECT_N(PotassiumFireColors_p,0)  break; // 
    case 20: EFFECT_N(ZebraColors_p,0)          break; // Зебра
    case 21: LEDS.showColor(CHSV(CLR,255,255)); break; // Цвет
} else LEDS.showColor(CRGB(0,0,0));
}
//--------------------------------------------------------
void parsing_WS2812(char act_chr[]){
    String act=String(act_chr);
    DEBUG("Modul WS2812 : ");
    DEBUGLN(act_chr);
    String strCommand=getValue(act,' ',0);
    String strParam=getValue(act,' ',1);
    strCommand.toUpperCase();
    strParam.toUpperCase();
    uint8_t intParam=str_to_int(strParam);

    String Effect_Name=NAME_EFF;
    Effect_Name.toUpperCase();
    FOR_i(0,MAX_EFF)
      { 
        if (getValue(Effect_Name,',',i)==strCommand) {
          Real_EFF=i;
          Power_EFF = true;
          if (intParam) BRI=intParam;
        }
      }
    
    if (strCommand=="EFF") {
      if (strParam == "+") Real_EFF = (Real_EFF+1) % MAX_EFF; else
      if (strParam == "-") Real_EFF = (MAX_EFF+Real_EFF-1) % MAX_EFF; else
      if (intParam < MAX_EFF) {Real_EFF = intParam; Power_EFF = true; }
    } else
    if (strCommand=="BRI") {
      if (strParam == "+") (BRI<255) ? BRI++ : 255 ; else
      if (strParam == "-") (BRI>0) ? BRI-- : 0 ; else
      BRI = intParam; 
      if (BRI) Power_EFF = true;
    } else
    if (strCommand=="SPD") {
      if (strParam == "+") (SPD<255) ? SPD++ : 255 ; else
      if (strParam == "-") (SPD>0) ? SPD-- : 0 ; else
      SPD = intParam; 
    } else
    if (strCommand=="CLR") {
      if (strParam == "+") (CLR<255) ? CLR++ : 255 ; else
      if (strParam == "-") (CLR>0) ? CLR-- : 0 ; else
      CLR = intParam; 
    } else

    if (strCommand=="SET") {   // команда SET eff bri spd sca
      Real_EFF=intParam;
      strParam=getValue(act,' ',2);
      intParam=str_to_int(strParam);
      if (strParam > "") { 
          BRI=intParam;
          if (BRI) Power_EFF = true;
          }
      strParam=getValue(act,' ',3);
      intParam=str_to_int(strParam);
      if (strParam > "") SPD=intParam;
      strParam=getValue(act,' ',4);
      intParam=str_to_int(strParam);
      if (strParam > "") SCA=intParam;
    } 

    
    
    if (strCommand=="P_ON") Power_EFF = true;
    if (strCommand=="P_OFF") Power_EFF = false;
    if (BRI==0) Power_EFF = false; 
    EVERY_MS(5000) 
    if (hub.focused() && HUB_Update) {
      hub.sendUpdate("EFF", String(Real_EFF));
      hub.sendUpdate("sw_EFF", String(Power_EFF));
      hub.sendUpdate("BRI", String(BRI));
      hub.sendUpdate("SPD", String(SPD));
      hub.sendUpdate("SCA", String(SCA));
      hub.sendUpdate("CLR", String(CLR));
      HUB_Update=false;
    }
}
//--------------------------------------------------------
void HUB_module_pult_WS2812() {
  hub.WidgetSize(74);
  hub.Select_("EFF",&Real_EFF,F(NAME_EFF),F("Эффект"));
  hub.WidgetSize(26);
  hub.Switch_("sw_EFF",&Power_EFF,F("Включить")); 
}
//--------------------------------------------------------
void HUB_module_WS2812() {
  String st_tab="0";
  static uint8_t tab = 0;
  hub.WidgetSize(74);
  hub.Select_("EFF",&Real_EFF,F(NAME_EFF),F("Эффект"));
  hub.WidgetSize(26);
  hub.Switch_("sw_EFF",&Power_EFF,F("Включить")); 
  hub.WidgetSize(100);
  hub.Slider_("BRI",&BRI,GH_UINT8, F("Яркость"), 0, 255, 1);
  hub.Slider_("SPD",&SPD,GH_UINT8, F("Скорость"), 0, 255, 1);
  hub.Slider_("SCA",&SCA,GH_UINT8, F("Масштаб"), 0, 255, 1);
  hub.Slider_("CLR",&CLR,GH_UINT8, F("Цвет"), 0, 255, 1);
/*  
   if (eeprom_flag) {
      FS_UPDATE(WS2812_R);
      eeprom_flag=false;
   }
*/   
}
//--------------------------------------------------------
void load_WS2812(){

}

//--------------------------------------------------------
// Утилиты для эффектов
//--------------------------------------------------------
void SaluteFadeAll(uint8_t val)
{ 
  FOR_i(0,NUM_LEDS) leds[i]-=CHSV(0,0,val);
}

//--------------------------------------------------------
// Эффекты
//--------------------------------------------------------
// Бег по кругу с затуханием
void effect_windows_round(uint8_t HUE_COLOR) {
   static uint8_t x = 0;
   leds[x++]=CHSV(HUE_COLOR,255,255);
   x=x % NUM_LEDS;
   SaluteFadeAll(30);
   FastLED.setBrightness(BRI);
   FastLED.show();
}
//--------------------------------------------------------
// Радуга по кругу
void effect_rainbow() {
   static uint8_t x = 0;
   FOR_i(0, NUM_LEDS) {
      leds[i] = CHSV(x++ + i*255/NUM_LEDS, 255,255); 
   }
   FastLED.setBrightness(BRI);
   FastLED.show();
}
//--------------------------
void fillNoiseLED()
{
  static uint16_t x;
  static uint16_t y;
  static uint16_t z;
  uint8_t dataSmoothing = 0;
  if (SPD < 50) dataSmoothing = 200 - (SPD * 4);

  for (uint8_t i = 0; i < NUM_LEDS; i++)
  {
    uint8_t data = inoise8(x + SCA * i, y , z);
    data = qsub8(data, 16);
    data = qadd8(data, scale8(data, 39));
      
    if (dataSmoothing)
    {
      uint8_t olddata = noise[i];
      uint8_t newdata = scale8( olddata, dataSmoothing) + scale8( data, 256 - dataSmoothing);
      data = newdata;
    }
    noise[i] = data;
  }
  x += 10;
  y += 20;
  z -= 5;

  for (uint8_t i = 0; i < NUM_LEDS; i++)
  {
      uint8_t bri =   noise[i];
      uint8_t index = noise[NUM_LEDS-i];
      if ( colorLoop) index += hue;
      if ( bri > 127 ) bri = 255;
      else bri = dim8_raw( bri * 2);
      CRGB color = ColorFromPalette( currentPalette, index, bri);      
      leds[i] = color;
  }
  hue += 1;
  FastLED.setBrightness(BRI);
  FastLED.show();
}

//--------------------------------


#endif
#endif
